<?php
session_name("n4ph4db6j1au16c2fcjc9tbqme");
session_set_cookie_params([
    'lifetime' => 600,
    'path' => '/',
    'domain' => $_SERVER['HTTP_HOST'],
    'secure' => true,
    'httponly' => true
]);
session_start();

$guest = true;

if (empty($_SESSION['csrf_token'])) {
    $_SESSION['csrf_token'] =  uniqid(true);
}

$users = [
        "root" => "g11cf47deb4jkjs3jlf965pb8f"
];

if (isset($_POST['submit'])) {
    if (!empty($_POST['user']) && !empty($_POST['password']) && !empty($_POST['_csrf_token'])) {
        $user = $_POST['user'];
        $password = $_POST['password'];
        $csrfToken = $_POST['_csrf_token'];

        if ($csrfToken == $_SESSION['csrf_token']) {
            if (array_key_exists($user, $users)) {
                if ($users[$user] == $password) {
                    $guest = false;
                    unset($_SESSION['csrf_token']);
                    session_destroy();
                    session_unset();
                }
            }
        }
    }
}

date_default_timezone_set("Asia/Dhaka");
$path = realpath('.');
$allFiles = [];

foreach (new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path)) as $filename) {
    $allFiles[] = [
        "filename" => "".$filename,
        "last_modified" => date ("Y-m-d H:i:s", filemtime($filename))
    ];
}

$keys = array_column($allFiles, 'last_modified');
array_multisort($keys, SORT_DESC, $allFiles);
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <title>Lastest Modified Files</title>
    <link rel="icon" sizes="16x16" href="https://cdn-icons-png.flaticon.com/128/622/622397.png">
    <link href="https://cdn.datatables.net/v/bs5/jq-3.6.0/dt-1.13.4/datatables.min.css" rel="stylesheet"/>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
</head>
<body>

<nav class="navbar bg-body-tertiary">
    <div class="container">
        <a class="navbar-brand" href="#">
            <img src="https://cdn-icons-png.flaticon.com/128/622/622397.png" alt="Bootstrap" width="30" height="24">
        </a>
    </div>
</nav>

<div class="container mt-3">
    <?php if ($guest): ?>
        <div class="row justify-content-center">
            <div class="col-md-4">
                <div class="card">
                    <div class="card-header">Login</div>
                    <div class="card-body">
                        <form action="" method="post">
                            <input type="hidden" name="_csrf_token" value="<?= $_SESSION['csrf_token'] ?>">
                            <div class="mb-3">
                                <label for="user" class="form-label">User</label>
                                <input type="text" name="user" class="form-control form-control-sm" id="user" placeholder="Enter User">
                            </div>
                            <div class="mb-3">
                                <label for="password" class="form-label">Password</label>
                                <input type="password" name="password" class="form-control form-control-sm" id="password" placeholder="Enter Password">
                            </div>
                            <input type="submit" name="submit" class="btn btn-primary btn-sm">
                        </form>
                    </div>
                </div>
            </div>
        </div>
    <?php else: ?>

    <div class="card">
        <div class="card-header">Lastest Modified Files</div>
        <div class="card-body">
            <table class="table table-sm display table-hover table-striped table-bordered" id="files" style="width:100%">
                <thead class="table-primary">
                <tr>
                    <th>File Name</th>
                    <th>Last Modified</th>
                </tr>
                </thead>
                <tbody>
                <?php foreach(array_chunk($allFiles, 10) as $chunk): ?>
                    <?php foreach ($chunk as $data): ?>
                        <tr>
                            <td><?= $data['filename'] ?> </td>
                            <td><?= $data['last_modified']; ?></td>
                        </tr>
                    <?php endforeach; ?>
                <?php endforeach; ?>
                </tbody>
            </table>
        </div>
    </div>

    <?php endif; ?>
</div>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-geWF76RCwLtnZ8qwWowPQNguL3RmwHVBC9FhGdlKrxdiJJigb/j/68SIy3Te4Bkz" crossorigin="anonymous"></script>
<script src="https://cdn.datatables.net/v/bs5/jq-3.6.0/dt-1.13.4/datatables.min.js"></script>
<script>
    $(document).ready(function () {
        $('#files').DataTable(
            {
                /* Disable initial sort */
                "aaSorting": []
            }
        );
    });
</script>
</body>
</html>
